
package core.synapse;

/**
 * This interface represent a synapse and define the synapse API
 * 
 * @author laurent.vanni@sophia.inria.fr - logNet team 2010 - INRIA
 *         Sophia-Antipolis - France
 *
 * Modified by Giang Ngo, giang.ngo_hoang@inria.fr 
 * - logNet team 2011 - INRIA Sophia-Antipolis - France
 */
public interface ISynapse {

	// THE SYNAPSE API
	public final static int SYNAPSEOFFER = 200;
	public final static int SYNAPSEGET = 201;
	public final static int SYNAPSERESULT = 202;
	public final static int SYNAPSEPING = 203;
	public final static int SYNAPSEPONG = 204;
	/**
	 * ask to invite a new peer in the synapse network
	 */
	public void invite();

	/**
	 * Join the synapse peer to a control network
	 * 
	 * @param host
	 *            the address of an entry of the control network
	 * @param port
	 *            the port number of an entry of the control network
	 */
	public void join(String host, int port);

}
