package org.planx.xmlstore.routing.operation;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import org.planx.xmlstore.routing.Identifier;
import org.planx.xmlstore.routing.Node;

public class DataLookupMessage extends LookupMessage {
	protected int count;
    protected DataLookupMessage() {}

    public DataLookupMessage(Node origin, Identifier lookup, int count) {
        super(origin, lookup);
        this.count = count;
    }

    public DataLookupMessage(DataInput in) throws IOException {
        super(in);
        count = in.readInt();
    }

    public void toStream(DataOutput out) throws IOException {
        super.toStream(out);
        out.writeInt(count);
    }

    public byte code() {
        return MessageFactoryImpl.CODE_DATA_LOOKUP;
    }
    
    public int getCount()
    {
    	return count;
    }
    public String toString() {
        return "DataLookupMessage[origin="+origin+",lookup="+lookup+",count="+count+"]";
    }
}