package org.planx.xmlstore.routing.operation;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.planx.xmlstore.routing.Node;

public class NodeReplyMessage2 extends NodeReplyMessage {
    protected int count;
    protected NodeReplyMessage2() {}

    public NodeReplyMessage2(Node origin, List nodes, int count) {
        super(origin, nodes);
        this.count = count;
    }

    public NodeReplyMessage2(DataInput in) throws IOException {
        fromStream(in);
    }

    public void fromStream(DataInput in) throws IOException {
        super.fromStream(in);
        count = in.readInt();
    }

    public void toStream(DataOutput out) throws IOException {
        super.toStream(out);
        out.writeInt(count);
    }

    public byte code() {
        return MessageFactoryImpl.CODE_NODE_REPLY_2;
    }
    public int getCount(){
    	return count;
    }

    public String toString() {
        return "NodeReplyMessage2[origin="+origin+",nodes="+nodes+"]";
    }
}    