/**
 * 
 * @author giang.ngo_hoang@inria.fr - logNet team 2011 - INRIA
 *         Sophia-Antipolis - France
 */
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;


public class ProcessLookupStats {
	public void process(String filename, String resultFile, String type)
	{
		int failed=0;
		int succeed=0;
		int hopcount = 0;
		int averageHopcount = 0;
		int averageSuccessfulLookupRatio = 0;
		WriteToFile writeToFile = new WriteToFile();
		String delimiter = ",";
		String[] temp;
		String strLine;		
		try{			
			FileInputStream fstream = new FileInputStream(filename);
			  DataInputStream in = new DataInputStream(fstream);
			  BufferedReader br = new BufferedReader(new InputStreamReader(in));			
			
			  br.readLine(); //pass the first line
			 
			  while ((strLine = br.readLine()) != null)   {
				  temp = strLine.split(delimiter);
				  if (temp[1].equals("null") || temp[1].equals("unreachable"))
				  {
					  failed++;
				  }
				  else 
				  {  
					  succeed++;
					  hopcount+=Integer.parseInt(temp[2]);
					  
				  }	  
			  }
	  
		}catch (Exception e){ 
			System.err.println("Error f1:" + e.getMessage()); 
		}
		
		if (succeed+failed != 0)
		{
			averageSuccessfulLookupRatio = succeed*100/(succeed+failed);

		if (succeed != 0)
			averageHopcount = hopcount/succeed;
		System.out.println("hopcount: "+hopcount+" succeed: "+succeed);
		
		String stats = averageSuccessfulLookupRatio+":"+averageHopcount
					+"\t\t#"+type+"AverageSuccessfulLookupRatio:averageHopcount";	
			writeToFile.write(resultFile, stats);
		}
	}
}
