/**
 * 
 * @author giang.ngo_hoang@inria.fr - logNet team 2011 - INRIA
 *         Sophia-Antipolis - France
 */
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;


public class ProcessMessageStatistic {
	public void process(String filename, String resultFile)
	{
		int synapseMessageNumbers = 0;
		int chordMessageNumbers = 0;
		int kadMessageNumbers = 0;

		int synapseTime = 0;
		int chordTime = 0;
		int kadTime = 0;

		int synapseNodeNumbers = 0;
		int kadNodeNumbers = 0;
		int chordNodeNumbers = 0;
		
		double synapse = 0;
		double chord = 0;
		double kad = 0;
		
		double percentSynapse;
		double percentChord;
		double percentKad;
		
		WriteToFile writeToFile = new WriteToFile();
		
		String delimiter1 = ":";
		String delimiter2 = ",";
		String[] temp1;
		String[] temp2;
		String strLine;		
		try{		
			  FileInputStream fstream = new FileInputStream(filename);
			  DataInputStream in = new DataInputStream(fstream);
			  BufferedReader br = new BufferedReader(new InputStreamReader(in));			
			 
			  br.readLine(); //pass the first line
			  
			  while ((strLine = br.readLine()) != null)   {
				  temp1 = strLine.split(delimiter1);
				  for (int i=0;i < temp1.length; i++)
				  {
					  temp2 = temp1[i].split(delimiter2);
					  if (temp2[0].equals("chord"))
					  {
						  chordNodeNumbers++;
						  chordMessageNumbers+=Integer.parseInt(temp2[1]);
						  chordTime+=Integer.parseInt(temp2[2]);
					  }
					  else if (temp2[0].equals("kad"))
					  {
						  kadNodeNumbers++;
						  kadMessageNumbers+=Integer.parseInt(temp2[1]);
						  kadTime+=Integer.parseInt(temp2[2]);
					  }
					  else if (temp2[0].equals("synapse"))
					  {
						  synapseNodeNumbers++;
						  synapseMessageNumbers+=Integer.parseInt(temp2[1]);
						  synapseTime+=Integer.parseInt(temp2[2]);
					  }
					  else //chordPlugin or KadPlugin
						  synapseMessageNumbers+=Integer.parseInt(temp2[1]);

				  }
			  }
			  
			  
		}catch (Exception e){ 
			System.err.println("Error f2:" + e.getMessage()); 
			
		}
/*		
		System.out.println("kad"+kadNodeNumbers+":"+kadMessageNumbers+":"+kadTime);
		System.out.println("chord"+chordNodeNumbers+":"+chordMessageNumbers+":"+chordTime);
		System.out.println("synapse"+synapseNodeNumbers+":"+synapseMessageNumbers+":"+synapseTime);
		System.out.println("plugin:"+pnum+":"+pmess);
*/
		
		synapse = (double)synapseMessageNumbers/(synapseTime/60);
		synapse = (double)Math.round(synapse*100)/100;
		
		chord = (double)chordMessageNumbers/(chordTime/60);
		chord = (double)Math.round(chord*100)/100;
		
		kad = (double)kadMessageNumbers/(kadTime/60);
		kad = (double)Math.round(kad*100)/100;
		
		int totalMessages = synapseMessageNumbers + chordMessageNumbers +kadMessageNumbers;
			
		percentSynapse = Math.round(((double)synapseMessageNumbers/totalMessages)*100);
		percentChord = Math.round(((double)chordMessageNumbers/totalMessages)*100);
		percentKad = Math.round(((double)kadMessageNumbers/totalMessages)*100);
				
		String messageStat= synapse+":"+chord+":"+kad+"\t#messagesPerNodePerMinutes(synapse:chord:kad)";
		String percenOfSynapse = percentSynapse+":"+percentChord+":"+percentKad+"\t#percentageOfMessage(Synapse:chord:kad)";
		writeToFile.write(resultFile, messageStat);
		writeToFile.write(resultFile, percenOfSynapse);
		
	}
}