/**
 * 
 * @author giang.ngo_hoang@inria.fr - logNet team 2011 - INRIA
 *         Sophia-Antipolis - France
 */

package manager;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Iterator;

public class Machines {
	protected ArrayList<ArrayList<String>> machineList; //name, ip, ports
	public static int machineIndex;
	public String managerIp;
	
	public Machines(String filename, boolean hostbyname)
	{
		String strLine;
		InetAddress address;
		String machineIp = null;
		machineList = new ArrayList<ArrayList<String>>();
		try{
			/*		
			InputStream is = this.getClass().getClassLoader().getResourceAsStream(filename);
			BufferedReader br = new BufferedReader(new InputStreamReader(is));
			 */		
					
			  FileInputStream fstream = new FileInputStream(filename);
			  DataInputStream in = new DataInputStream(fstream);
			  BufferedReader br = new BufferedReader(new InputStreamReader(in));	
			
			while ((strLine = br.readLine()) != null)   {
				machineIp = null;
				if (hostbyname == true)
				{
					address = null;
					  try {
					      address = InetAddress.getByName(strLine);
					    } catch (UnknownHostException e) {		     
					    }
					if (address != null)
						machineIp = address.getHostAddress();
				}
				
				else 
					machineIp = strLine;
				
				if (!(machineIp == null))
				{  ArrayList machine = new ArrayList();
				  machine.add(machineIp);
				  machine.add("0");
				  machineList.add(machine);
			  	}
			}
			  in.close();
		}catch (Exception e){ 	
			  System.err.println("Error: " + e.getMessage());
		}
		
		managerIp = machineList.get(0).get(0);
		if (machineList.size() > 1)
				machineList.remove(0);	
		
		machineIndex = 0;
		//debug  
		int index = machineList.size();
		System.out.println("Machines");
		for (int i = 0; i< index; i++)
		{				
			System.out.println(machineList.get(i).get(0)+":"+machineList.get(i).get(1));
		}
	}

	
	 public synchronized String getMachine(String nodeType, int numberOfPlugins)
	 {
		 
		 int port;

		 if (machineIndex >= machineList.size()) 
			 machineIndex = 0;
		 
		 String machineIp = machineList.get(machineIndex).get(0);
		 port = Integer.parseInt(machineList.get(machineIndex).get(1));
		 
		 
		 if (port == 0 || port == 60000) 
			 port = 6000;
		 else 
			 port = port+1;	
		 
		 //update used port list and point to next machine
		 machineList.get(machineIndex).remove(1);				 
		 
		 if (nodeType.equals("KAD")) 		 
			 machineList.get(machineIndex).add(Integer.toString(port+1));
		 
		 else if (nodeType.equals("CHORD")) 
			 machineList.get(machineIndex).add(Integer.toString(port));
		 
		 else if (nodeType.equals("SYNAPSE")) 		 
			 machineList.get(machineIndex).add(Integer.toString(port+numberOfPlugins*2));
		 
		 machineIndex++;
			
		 //debug
			 
		 return machineIp+","+port;
		 
	 }
	 
	 
		public void printMachines()
		{
			
			Iterator iter = machineList.iterator();
			while (iter.hasNext())
			{
				System.out.println("machines: "+iter.next().toString());
			}
			
		}
}
