/**
 * This class represent the node information of a peer
 * 
 * @author laurent.vanni@sophia.inria.fr - logNet team 2010 - INRIA
 *         Sophia-Antipolis - France
 *  
 *  Modified by giang.ngo_hoang@inria.fr 
 * - logNet team 2011 - INRIA Sophia-Antipolis - France

 * 
 */

package manager;

public class NodeInfo {
	
	private Node node;
	private int port = 0;
	
	public NodeInfo(Node node){
		this.node = node;
	}
	
	public NodeInfo(Node node, int port) {
		this.node = node;
		this.port = port;
	}
	
	public String toString(){
		return node.getIp() + ":" +node.getId()+":" +node.getPort() + ":" + port;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof NodeInfo) {
			NodeInfo n = (NodeInfo) obj;
			Node m = n.getNode();
			return node.equals(m);
		}
		return false;
	}

	public Node getNode() {
		return node;
	}
	public int getPort() {
		return port;
	}
}
